<template>
  <label class="input-file">
    <input
      type="file"
      accept="image/jpeg, image/png"
      @change="onFileChange"
    />

    <q-img
      :src="image"
      class="input-file__preview"
      no-default-spinner
    />

    <div v-if="!isLoadingAvatar && !files.length" class="input-file__placeholder">{{ $t('uploadAvatar') }}</div>

    <q-spinner-ios
      v-if="isLoadingAvatar"
      color="primary"
      size="2em"
      class="input-file__spinner"
    />
  </label>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api'

let avatar = null

export default defineComponent({
  name: 'InputUploadFile',

  setup (props, ctx) {
    const files = ref({})
    const image = ref()
    const isLoadingAvatar = ref(false)

    function GetImagePreviews () {
      isLoadingAvatar.value = true

      for (const key in files.value) {
        if (/\.(jpe?g|png|gif)$/i.test(files.value[key].name)) {
          const reader = new FileReader()

          reader.addEventListener('load', function () {
            image.value = reader.result
            avatar = reader.result
            isLoadingAvatar.value = false

            ctx.emit('onChange', avatar)
          }, false)

          reader.readAsDataURL(files.value[key])
        }
      }
    }

    function onFileChange (e) {
      files.value = e.target.files || e.dataTransfer.files

      if (!files.value.length) { return }

      GetImagePreviews()
    }

    return {
      files,
      image,
      onFileChange,
      isLoadingAvatar
    }
  }
})
</script>

<style lang="scss" scoped>
@import '../css/variables';

.input-file {
  position: relative;
  display: flex;
  height: 200px;
  width: 100%;
  max-width: 150px;
  box-shadow: 1px 1px 0 $colorBorder inset, -1px -1px 0 $colorBorder inset;
  background-color: #ffffff29;
  justify-content: center;
  margin: auto;
  overflow: hidden;

  input {
    outline: 0;
    opacity: 0;
    pointer-events: none;
    user-select: none;
    position: absolute;
    width: 100%;
    height: 100%;
  }

  &:hover {
    box-shadow: 1px 1px 0 $colorHover inset, -1px -1px 0 $colorHover inset;
    cursor: pointer
  }

  &__preview {
    min-width: 100%;
    min-height: 100%;
    position: absolute;
  }

  &__placeholder,
  &__spinner {
    position: absolute;
    height: 100%;
    align-items: center;
    display: flex;
    text-align: center;
  }
}
</style>
